package com.jpattern.orm.generator.reflection;

import java.lang.reflect.InvocationTargetException;
import java.sql.ResultSet;

/**
 * 
 * @author Francesco Cina'
 *
 * Mar 31, 2012
 */
public class FieldManipulator {

	private final AGetFieldManipulator get;
	private final ASetFieldManipulator set;
	private final String columnName;

	public FieldManipulator(AGetFieldManipulator get, ASetFieldManipulator set, String columnName) {
		this.get = get;
		this.set = set;
		this.columnName = columnName;
	}

	//Set the value of the field
	public void setValue(Object bean, Object value) throws IllegalArgumentException, IllegalAccessException, InvocationTargetException {
		set.setValue(bean, value);
	}

	public void setValueFromResultSet(Object bean, ResultSet rs, String rsColumnName) throws IllegalArgumentException, IllegalAccessException,	InvocationTargetException {
		set.setValueFromResultSet(bean, rs, rsColumnName);
	}

	public void setValueFromResultSet(Object bean, ResultSet rs, int rsColumnIndex) throws IllegalArgumentException, IllegalAccessException,	InvocationTargetException {
		set.setValueFromResultSet(bean, rs, rsColumnIndex);
	}

	//get the value of the field
	public Object getValue(Object bean) throws IllegalArgumentException, IllegalAccessException, InvocationTargetException {
		return get.getValue(bean);
	}

	//The DB column name
	public String getColumnName() {
		return columnName;
	}

}
