package com.jpattern.orm.session;

import java.util.List;

import com.jpattern.orm.exception.OrmException;

/**
 * 
 * @author Francesco Cina'
 *
 * Dec 20, 2011
 */
public interface SqlPerformerStrategy {

	void execute(String sql, int timeout) throws OrmException;

	<T> T query(SqlSelectQuery sqlSelectQuery, ResultSetReader<T> rse) throws OrmException ;

	int update(String sql, int timeout, Object... args) throws OrmException;
	
	int update(String sql, int timeout, GeneratedKeyReader generatedKeyReader, Object... args) throws OrmException;

	int[] batchUpdate(List<String> sqls, int timeout) throws OrmException;

	int[] batchUpdate(String sql, List<Object[]> args, int timeout) throws OrmException;

	int[] batchUpdate(String sql, PreparedStatementCreator psc, int timeout) throws OrmException;
	
}
